-- Original script: d47 strawmod
-- universal bale ready, fixed unloading, autoload, safe/load trailer state: Bassaddict
-- woolpallet ready: Steve007
-- fix save and quitting game with loaded trailer, make 15 happy, added mass to load, move hud display to help menu: Goelm

ubt = {};

function ubt.prerequisitesPresent(specializations)
    return true;
end;

function ubt:load(xmlFile)
	self.unloadLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.unloadLeft#index"));
	self.unloadRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.unloadRight#index"));
	self.unloadBack = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.unloadBack#index"));
	self.trailerIsEmpty = true;
	self.autoLoad = false;
	self.autoLoadText = {g_i18n:getText("AUTOLOAD_MANUAL"),g_i18n:getText("AUTOLOAD_AUTOMATIC")};
	self.loadingIsActive = false;
	self.wasToFast = false;
	self.wasToFast = false;
	self.displayHUD = true;
	self.massScale = 0;
	self.sBz = false;
	self.hBz = false;
	self.wPz = false;
	self.hBalez = 0;
	self.sBalez = 0;
	self.wPalletz = 0;
	self.bPalletz = 0;
	self.tPalletz = 0;
	self.smallBaleMass = 0.13093;
	self.typeOnTrailer = 1;
	self.ulMode = 1;
	self.uEmptyMass = getMass(self.components[1].node)
	self.ulRef = {{g_i18n:getText("UNLOAD_LEFT"),false,self.unloadLeft},{g_i18n:getText("UNLOAD_BACK"),false,self.unloadBack},{g_i18n:getText("UNLOAD_RIGHT"),false,self.unloadRight},{g_i18n:getText("UNLOAD_TRAILER"),false,0}};	
	self.numAttacherParts = Utils.getNoNil(getXMLInt(xmlFile,"vehicle.attacherParts#count"), 0);
	self.numAttachers = {};
	self.attacher = {};
	self.attacherLevel = {};
	self.baleType = {};
	for i=1,self.numAttacherParts do
		self.numAttachers[i] = Utils.getNoNil(getXMLInt(xmlFile, string.format("vehicle.Attachers".."%d".."#count",i)), 0);
		self.baleType[i] = {g_i18n:getText(Utils.getNoNil(getXMLString(xmlFile, string.format("vehicle.Attachers".."%d".."#type",i))), "nil"),i};
		self.attacher[i] = {};
		self.attacherLevel[i] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, string.format("vehicle.Attachers".."%d".."#index",i)));
		for j=1,self.numAttachers[i] do
			self.attacher[i][j] = {};
			local partnamej = string.format("vehicle.Attachers".."%d"..".objectAttacher".."%d",i,j);
			self.attacher[i][j].object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamej.."#index"));
			self.attacher[i][j].attachedObject = nil;
			self.attacher[i][j].objectInRange = nil;
		end;
	end;
	self.fillULevel = 0;
    self.fillULevelMax = self.numAttachers[self.typeOnTrailer];
end;

function ubt:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		local tmptOT = Utils.getNoNil(getXMLInt(xmlFile, key.."#tOT"), 1);
		local hb = Utils.getNoNil(getXMLInt(xmlFile, key.."#hay"), 0);
		local sb = Utils.getNoNil(getXMLInt(xmlFile, key.."#straw"), 0);
		local wp = Utils.getNoNil(getXMLInt(xmlFile, key.."#pallet"), 0);
		local bp = Utils.getNoNil(getXMLInt(xmlFile, key.."#bpallet"), 0);
		local tp = Utils.getNoNil(getXMLInt(xmlFile, key.."#tpallet"), 0);
		self.fillULevel = Utils.getNoNil(getXMLInt(xmlFile, key.."#fillULevel"), 0);
		local tmpUlMode = Utils.getNoNil(getXMLInt(xmlFile, key.."#ulMode"), 1);
		local tmpAutoLoad = Utils.getNoNil(getXMLBool(xmlFile, key.."#autoLoad"), false);
		local tmpDisplayHUD = Utils.getNoNil(getXMLBool(xmlFile, key.."#displayHUD"), true);
		self.trailerVis = Utils.getNoNil(getXMLBool(xmlFile, key.."#trailerVis"), false);
		if self.trailerVis then
			setVisibility(self.liveStock, true);
			setVisibility(self.baleGates, false);
		end;
		if tmptOT ~= nil then
			self.typeOnTrailer = tmptOT;
			self.fillULevelMax = self.numAttachers[self.typeOnTrailer];
		end;
		if tmpUlMode ~= nil then
			self.ulMode = tmpUlMode;
		end;
		if tmpAutoLoad ~= nil then
			self.autoLoad = tmpAutoLoad;
		end;
		if tmpDisplayHUD ~= nil then
			self.displayHUD = tmpDisplayHUD;
		end;
		local tb = sb + hb + wp + bp + tp;
		if tb == 0 then
			self.getThatLoad = false;
		else
			self.getThatLoad = true;
		end;
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function ubt:getSaveAttributesAndNodes(nodeIdent)
	self.backMode = self.ulRef[self.ulMode][1]
	if not self.trailerIsEmpty then
		self.ulRef[self.ulMode][1] = "Trailer"
		for i=1, self.fillULevel do
			if self.attacher[self.typeOnTrailer][i].attachedObject ~= nil then
				ubt:ObjectDetachUbt(self,i);
			end;
		end;
		self.getThatLoad = true;
	end;
	self.ulRef[self.ulMode][1] = self.backMode
	local tmpAutoLoad;
	local tmpDisplayHUD;
	if self.autoLoad then
		tmpAutoLoad = "true";
	else
		tmpAutoLoad = "false";
	end;
	if self.displayHUD then
		tmpDisplayHUD = "true";
	else
		tmpDisplayHUD = "false";
	end;
	local attributes = string.format('fillULevel="%d" tOT="%d" hay="%d" straw="%d" pallet="%d" bpallet="%d" tpallet="%d" ulMode="%d" autoLoad="%s" displayHUD="%s" trailerVis="%s"',self.fillULevel,self.typeOnTrailer,self.hBalez,self.sBalez,self.wPalletz,self.bPalletz,self.tPalletz,self.ulMode,tmpAutoLoad,tmpDisplayHUD,self.trailerVis);
	return attributes, nil;
end;

function ubt:delete()
	self.ulRef[self.ulMode][1] = "Trailer"
	if (not self.trailerIsEmpty) then
		for i=1, self.fillULevel do
			if self.attacher[self.typeOnTrailer][i].attachedObject ~= nil then
				ubt:ObjectDetachUbt(self,i);
			end;
		end;
	end;
end;

function ubt:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ubt:keyEvent(unicode, sym, modifier, isDown)
end;

function ubt:update(dt)
-- 
--print(self.ucurrentMass )

	if self.typeOnTrailer ~= 6 and not self.trailerVis and self.currentFillType == 0 then
		if self.typeOnTrailer == 1 then
			self.massScale = 0.442;
			self.capacity = 60;
			self.fillLevel = self.fillULevel;
		elseif self.typeOnTrailer == 2 then
			self.massScale = 0.462;
			self.capacity = 34;
			self.fillLevel = self.fillULevel;
		elseif self.typeOnTrailer == 3 then
			self.massScale = 0.494;
			self.capacity = 14;
			self.fillLevel = self.fillULevel;
		elseif self.typeOnTrailer == 4 then
			self.massScale = 1.62;
			self.capacity = 8;
			self.fillLevel = self.fillULevel;
		elseif self.typeOnTrailer == 5 then
			self.massScale = 0.102;
			self.capacity = 14;
			self.fillLevel = self.fillULevel;
		end;
	end;
-- Restore saved load
	if self.getThatLoad then
		self.getThatLoad = false;
		self.fillULevel = 0;
		for i=1, self.numAttachers[self.typeOnTrailer] do
			if self.attacher[self.typeOnTrailer][i].attachedObject == nil then
				local nearest = ubt:ObjectInRangeUbt(self,i);
				if nearest ~= nil then
					self.attacher[self.typeOnTrailer][i].objectInRange = nearest;
					ubt:ObjectAttachUbt(self,i);
				else
				break;
				end;
			end;
		end;
	end;
	
		if self.typeOnTrailer ~= 6 or self.fillULevel ~= 0 then
		setVisibility(self.liveStock, false);
		self.trailerVis = false;
		setVisibility(self.baleGates, true);
		end;
		if self.typeOnTrailer == 6 then
		setVisibility(self.liveStock, true);
		self.trailerVis = true;
		setVisibility(self.baleGates, false);
		end;
		if self.filllLevel ~= 0 and self.currentFillType ~= 0 then
		setVisibility(self.liveStock, true);
		self.trailerVis = true;
		setVisibility(self.baleGates, false);
		end;
-- input loop
	if self:getIsActiveForInput() then
		-- bale loading
		if InputBinding.hasEvent(InputBinding.ubtATTACH) and (not self.autoLoad) then
			for i=1, self.numAttachers[self.typeOnTrailer] do
				if self.attacher[self.typeOnTrailer][i].attachedObject == nil then
					local nearest = ubt:ObjectInRangeUbt(self,i);
					if nearest ~= nil then
						self.attacher[self.typeOnTrailer][i].objectInRange = nearest;
						ubt:ObjectAttachUbt(self,i);
					else
						break;
					end;
				end;
			end;
		end;
		if InputBinding.hasEvent(InputBinding.ubtATTACH) and self.autoLoad then
			if self.loadingIsActive then
				self.loadingIsActive = false;
			else
				self.loadingIsActive = true;
			end;
		end;
		-- bale unloading
		if InputBinding.hasEvent(InputBinding.ubtDETACH) and not self.loadingIsActive then
			for i=1, self.numAttachers[self.typeOnTrailer] do		
				if self.attacher[self.typeOnTrailer][i].attachedObject ~= nil then				
					ubt:ObjectDetachUbt(self,i);
					self.fillULevel = self.fillULevel - 1;
				end;
			end;
			self.hBalez = 0;
			self.sBalez = 0;
			self.wPalletz = 0;
			self.bPalletz = 0;
			self.tPalletz = 0;
			--self.fillULevel = 0;
			self.fillLevel = self.fillULevel;
		end;
		-- toggle unloading side (left, back, right, trailer)
		if InputBinding.hasEvent(InputBinding.ubtTOGGLEUNLOAD) then
			if self.ulMode == 4 then
				self.ulMode = 0;
			end;
			self.ulMode = self.ulMode + 1;
		end;
		-- toggle bale type (normal, round, wool, board, sapling)
		if InputBinding.hasEvent(InputBinding.ubtTOGGLEBALETYPE) then
			if self.trailerIsEmpty then
				if self.typeOnTrailer == 6 then
					self.typeOnTrailer = 0;
				end;
				self.typeOnTrailer = self.typeOnTrailer + 1;
				self.fillULevelMax = self.numAttachers[self.typeOnTrailer];
			end;
		end;
		-- toggle loading type (automatic, manual)
		if InputBinding.hasEvent(InputBinding.ubtTOGGLELOADINGTYPE) then
			if self.autoLoad and (not self.loadingIsActive) then
				self.autoLoad = false;
			else
				self.autoLoad = true;
			end;
		end;
		--toggle displaying HUD
		if InputBinding.hasEvent(InputBinding.ubtTOGGLEHUD) then
			if self.displayHUD then
				self.displayHUD = false;
			else
				self.displayHUD = true;
			end;
		end;
	end;
		local newMass = self.uEmptyMass + self.fillLevel*self.massScale;
    if newMass ~= self.ucurrentMass then
		setMass(self.components[1].node, newMass);
		self.ucurrentMass = newMass;
	end;
end;

function ubt:updateTick(dt)
	if self.fillULevel == 0 then
		self.trailerIsEmpty = true;
	else
		self.trailerIsEmpty = false;
	end;
	self.wasToFast = false;
	if self:getIsActive() and self.attacherVehicle ~= nil then
		--stop autoload if trailer is full
		if self.fillULevel == self.fillULevelMax then
			self.loadingIsActive = false;
		end;
		-- autoload
		local toFast = self.attacherVehicle.lastSpeed*3600 > 45;
		if self.autoLoad and self.loadingIsActive then
			if not toFast then
				local i = self.fillULevel+1;
				if self.attacher[self.typeOnTrailer][i].attachedObject == nil then
					local nearest = ubt:ObjectInRangeUbt(self,i);
					if nearest ~= nil then
						self.attacher[self.typeOnTrailer][i].objectInRange = nearest;
						ubt:ObjectAttachUbt(self,i);
					end;
				end;
			end;
			self.wasToFast = toFast;
		end;
	end;
end;

function ubt:draw()
	setTextBold(false);
	if self.wasToFast then
        g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast"), 0.07+0.022, 0.019+0.045);
		--.."\n"..string.format(g_i18n:getText("Cruise_control_levelN"), "2", InputBinding.getKeyNamesOfDigitalAction(InputBinding.SPEED_LEVEL2)), 0.07+0.022, 0.019+0.045);
    end;
	setTextAlignment(RenderText.ALIGN_RIGHT);
	local tmpALText;
	if self.autoLoad then
		tmpALText = self.autoLoadText[2];
	else
		tmpALText = self.autoLoadText[1];
	end;
	if self.displayHUD and self.currentFillType == 0 and not self.trailerVis then
		if (self.hBalez + self.sBalez) >= 1 then
			renderText(0.70, 0.94, 0.02,string.format("Cat Flatbed No: (%d/%d), Hay: %d, Straw: %d, Product: %s, Side: %s, Mode: %s",self.fillULevel,self.fillULevelMax,self.hBalez,self.sBalez,self.baleType[self.typeOnTrailer][1],self.ulRef[self.ulMode][1],tmpALText));
		else
			renderText(0.70, 0.94, 0.02,string.format("Cat Flatbed No: (%d/%d), Product: %s, Side: %s, Mode: %s",self.fillULevel,self.fillULevelMax,self.baleType[self.typeOnTrailer][1],self.ulRef[self.ulMode][1],tmpALText));
		end;
	else
		if self.displayHUD and (self.currentFillType ~= 0 or self.typeOnTrailer == 6) then
			local desc = Fillable.fillTypeIndexToDesc[self.currentFillType];
			if desc ~= nil then
				local name = desc.name;
					if name == 'pig' then
						name = 'Pig'
					elseif name == 'beef' then
						name = 'Beef'
					elseif name == 'chicken' then
						name = 'Chicken'
					elseif name == 'sheep' then
						name = 'Sheep'
					end;
				local capact = self.CargoCapacity[self.currentFillType] or self.CargoCapacity["default"];
				renderText(0.60, 0.94, 0.02,string.format("Cat Livestock Trailer: (%d/%d), Product: %s",self.fillLevel,capact,name));
			else
				local name = "Empty";
				local capact = self.CargoCapacity[self.currentFillType] or self.CargoCapacity["default"];
				renderText(0.60, 0.94, 0.02,string.format("Cat Livestock Trailer: (%d/%d), Product: %s",self.fillLevel,capact,name));
			end;
		end;
	end;
	--setTextAlignment(RenderText.ALIGN_LEFT);
	if self.currentFillType == 0 and not self.trailerVis then
		if self.displayHUD then
			if self.autoLoad then
				if self.loadingIsActive then
					g_currentMission:addHelpButtonText(g_i18n:getText("UBT_STOP_AUTOLOAD"),InputBinding.ubtATTACH);
				else
					g_currentMission:addHelpButtonText(g_i18n:getText("UBT_START_AUTOLOAD"),InputBinding.ubtATTACH);
				end;
			else
				g_currentMission:addHelpButtonText(g_i18n:getText("UBT_LOAD"),InputBinding.ubtATTACH);
			end;
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_UNLOAD"),InputBinding.ubtDETACH);
			if self.fillLevel == 0 then
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_TOGGLE_BALE_TYPE"),InputBinding.ubtTOGGLEBALETYPE);
			end;
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_TOGGLE_UNLOAD_SIDE"),InputBinding.ubtTOGGLEUNLOAD);
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_TOGGLE_LOADING_TYPE"),InputBinding.ubtTOGGLELOADINGTYPE);
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_HUD_HIDE"),InputBinding.ubtTOGGLEHUD);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_HUD_SHOW"),InputBinding.ubtTOGGLEHUD);
			--g_currentMission:addHelpButtonText(g_i18n:getText("UBT_TOGGLE_BALE_TYPE"),InputBinding.ubtTOGGLEBALETYPE);
		end;
	else
		if self.displayHUD and self.currentFillType == 0 then
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_HUD_HIDE"),InputBinding.ubtTOGGLEHUD);
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_TOGGLE_BALE_TYPE"),InputBinding.ubtTOGGLEBALETYPE);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("UBT_HUD_SHOW"),InputBinding.ubtTOGGLEHUD);
		end;
	end;
end;

function ubt:ObjectInRangeUbt(self,k)
	local nearestObject;
	local itemNode;
	local index;
	local nearestDistance = 15;
	local objectCopy = self.attacher[self.typeOnTrailer][k].object;
	local px, py, pz = getWorldTranslation(objectCopy);
	for index, item in pairs(g_currentMission.itemsToSave) do
		itemNode = item.item.nodeId;
		if getParent(item.item.nodeId) == getRootNode() then
			local vx, vy, vz = getWorldTranslation(itemNode);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			--print(item.item.i3dFilename)
			if distance < nearestDistance then
				--[[local tmpItemMass = getMass(itemNode);
				tmpItemMass = round(tmpItemMass,5);
				if self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_BIG") then
					if (getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale")) and not (item.item.i3dFilename == "data/maps/models/objects/squarebales/baleHay240.i3d" or not item.item.i3dFilename == "data/maps/models/objects/squarebales/baleStraw240.i3d") and not (tmpItemMass == self.smallBaleMass) then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_SMALL") then
					if tmpItemMass == self.smallBaleMass then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;]]--
				if self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_NORMAL") and item.item.i3dFilename == "data/maps/models/objects/squarebales/baleHay240.i3d" then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
						self.hBz = true;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_NORMAL") and item.item.i3dFilename == "data/maps/models/objects/squarebales/baleStraw240.i3d" then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
						self.sBz = true;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_ROUND") and item.item.i3dFilename == "data/maps/models/objects/roundbales/roundbaleHay_w112_d130.i3d" then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
						self.hBz = true;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BALETYP_ROUND") and item.item.i3dFilename == "data/maps/models/objects/roundbales/roundbaleStraw_w112_d130.i3d" then
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
						self.sBz = true;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("WOOLPALLET") then
					if item.item.i3dFilename == "data/maps/models/objects/pallets/woolPallet.i3d" then
						self.wPz = true;
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("TREEPALLET") then
					if item.item.i3dFilename == "data/objects/pallets/treeSaplingPallet.i3d" then
						self.tPz = true;
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				elseif self.baleType[self.typeOnTrailer][1] == g_i18n:getText("BOARDPALLET") then
				local board = trim(item.item.i3dFilename)
					if board == "boardPallet.i3d" then
						self.bPz = true;
						index = index;
						nearestObject = itemNode;
						nearestDistance = distance;
					end;
				end;
			end;
		end;
	end;
	return nearestObject
end;
function trim(s)
  local l = string.sub(s, -15)
  return l
end
--[[function round(what, precision)
	local tempRes;
	tempRes = math.floor((what*math.pow(10,precision))+0.5) / math.pow(10,precision);
	return tempRes;
end;]]--

function ubt:ObjectAttachUbt(self,l)
	local x,y,z = getWorldRotation(self.attacher[self.typeOnTrailer][l].objectInRange);
	removeFromPhysics(self.attacher[self.typeOnTrailer][l].objectInRange);	
	setTranslation(self.attacher[self.typeOnTrailer][l].objectInRange, 0,0,0);
	setRotation(self.attacher[self.typeOnTrailer][l].objectInRange, 0,0,0);
	link(self.attacher[self.typeOnTrailer][l].object,self.attacher[self.typeOnTrailer][l].objectInRange);
	self.attacher[self.typeOnTrailer][l].attachedObject = self.attacher[self.typeOnTrailer][l].objectInRange;
	self.attacher[self.typeOnTrailer][l].objectInRange = nil;
	self.fillULevel = self.fillULevel + 1;
	self.fillLevel = self.fillULevel;
	if self.hBz then
		self.hBalez = self.hBalez + 1;
	elseif self.sBz then
		self.sBalez = self.sBalez + 1;
	elseif self.wPz then
		self.wPalletz = self.wPalletz + 1
	elseif self.bPz then
		self.bPalletz = self.bPalletz + 1
	elseif self.tPz then
		self.tPalletz = self.tPalletz + 1
	end;
	self.hBz = false;
	self.sBz = false;
	self.wPz = false;
	self.bPz = false;
	self.tPz = false;
end;

function ubt:ObjectDetachUbt(self,k)
	if self.ulRef[self.ulMode][1] == g_i18n:getText("UNLOAD_TRAILER") then
			if self.attacher[self.typeOnTrailer][k].attachedObject ~= nil then
				local x,y,z = getWorldTranslation(self.attacher[self.typeOnTrailer][k].attachedObject);
				local rx,ry,rz = getWorldRotation(self.attacher[self.typeOnTrailer][k].attachedObject);
				local root = getRootNode();
				setTranslation(self.attacher[self.typeOnTrailer][k].attachedObject,x,y,z);
				setRotation(self.attacher[self.typeOnTrailer][k].attachedObject,rx,ry,rz);
				addToPhysics(self.attacher[self.typeOnTrailer][k].attachedObject);
				link(root,self.attacher[self.typeOnTrailer][k].attachedObject);
				self.attacher[self.typeOnTrailer][k].attachedObject = nil;
			end;
	else
		if self.attacher[self.typeOnTrailer][k].attachedObject ~= nil then
			local x,y,z = getWorldTranslation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local rx,ry,rz = getWorldRotation(self.attacher[self.typeOnTrailer][k].attachedObject);
			local nx,ny,nz = getWorldTranslation(self.attacherLevel[self.typeOnTrailer]);
			local tx,ty,tz = getWorldTranslation(self.ulRef[self.ulMode][3]);
			local x = x + (tx - nx);
			local y = y + (ty - ny);
			local z = z + (tz - nz);
			local tH = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
			local relHeight = ny - tH;
			local root = getRootNode();
			setTranslation(self.attacher[self.typeOnTrailer][k].attachedObject,x,(y - relHeight),z);
			setRotation(self.attacher[self.typeOnTrailer][k].attachedObject,rx,ry,rz);
			addToPhysics(self.attacher[self.typeOnTrailer][k].attachedObject);
			link(root,self.attacher[self.typeOnTrailer][k].attachedObject);
			self.attacher[self.typeOnTrailer][k].attachedObject = nil;
		end;
	end;
end;

function ubt:onDetach()
	self.loadingIsActive = false;
end;

function ubt:onLeave()
	self.loadingIsActive = false;
end;

function ubt:readStream(streamId, connection)
end;

function ubt:writeStream(streamId, connection)   
end;
